routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\SubCategoryController;


Route::resource('/', CategoryController::class);

Route::resource('category', CategoryController::class);
Route::resource('sub_category', SubCategoryController::class);
Route::resource('product', ProductController::class);

Route::get('category/products/{category_id}', [ProductController::class , 'category_products']);
Route::get('category/sub_categories/{category_id}', [SubCategoryController::class , 'category_sub_categories']);
Route::get('sub_category/products/{sub_category_id}', [ProductController::class , 'sub_category_products']);

app/Models/SubCategory.php
<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class SubCategory extends Model
{
	use SoftDeletes;
	protected $table = 'sub_categories';

	protected $casts = [
		'category_id' => 'int',
		'is_active' => 'bool'
	];

	protected $fillable = [
		'category_id',
		'name',
		'code',
		'is_active'
	];

	public function category()
	{
		return $this->belongsTo(Category::class);
	}

	public function products()
	{
		return $this->hasMany(Product::class);
	}
}

app/Http/Controllers/SubCategoryController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\SubCategory;
use Illuminate\Http\Request;

class SubCategoryController extends Controller
{

    public function index()
    {
        $sub_categories = SubCategory::with(['category'])->latest()->paginate(5);

        return view('sub_category.index', compact('sub_categories'))
            ->with('i', (request()->input('page', 1) - 1) * 5);
    }

    public function category_sub_categories(Request $request)
    {
        $category_id = $request->route('category_id');
        $sub_categories = SubCategory::with(['category'])
            ->where('category_id', '=', $category_id)->latest()->paginate(5);

        return view('sub_category.index', compact('sub_categories'))
            ->with('i', (request()->input('page', 1) - 1) * 5);
    }


    public function create()
    {
        $categories = Category::where('is_active', '=', true)->get();
        return view('sub_category.create', compact('categories'));
    }


    public function store(Request $request)
    {
        $request->validate([
            'name' => [
                'required',
                'unique:sub_categories,name'
            ],
            'code' => [
                'required',
                'unique:sub_categories,code'
            ],
            'category_id' => 'required'
        ]);

        SubCategory::create($request->all());

        return redirect()->route('sub_category.index')
            ->with('success', 'Sub Category created successfully.');
    }

    public function show(SubCategory $sub_category)
    {
        return view('sub_category.show', compact('sub_category'));
    }


    public function edit(SubCategory $sub_category)
    {
        $result['categories'] = Category::where('is_active', '=', true)->get();
        $result['sub_category'] = $sub_category;
        return view('sub_category.edit', compact('result'));
    }

    public function update(Request $request, SubCategory $sub_category)
    {
        $request->validate([
            'name' => [
                'required',
                function ($a, $v, $f) use ($sub_category) {
                    if (SubCategory::where('id', '!=', $sub_category->id)->where('name', '=', $v)->exists()) {
                        $f("Name Aleady taken");
                    }
                }
            ],
            'category_id' => 'required',
            'code' => [
                'required',
                function ($a, $v, $f) use ($sub_category) {
                    if (SubCategory::where('id', '!=', $sub_category->id)->where('code', '=', $v)->exists()) {
                        $f("Code Aleady taken");
                    }
                }
            ]
        ]);
        $sub_category->update($request->all());

        return redirect()->route('sub_category.index')
            ->with('success', 'Sub Category updated successfully');
    }

    public function destroy(SubCategory $sub_category)
    {
        $sub_category->delete();

        return redirect()->route('sub_category.index')
            ->with('success', 'Sub Category deleted successfully');
    }
}

resources/views/sub_category/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Add New Sub-Category</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('sub_category.index') }}" title="Go back"> <i class="fas fa-backward "></i> </a>
            </div>
        </div>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            <strong>Whoops!</strong> There were some problems with your input.<br><br>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif
    <form action="{{ route('sub_category.store') }}" method="POST" >
        @csrf

        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Category:</strong>
                    <select class="form-control" name="category_id">
                        @foreach ($categories as $i => $category)
                        <option value="{{ $category->id }}">{{ $category->name }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Name:</strong>
                    <input type="text" name="name" class="form-control" placeholder="Name">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Code:</strong>
                    <input type="text" name="code" class="form-control" placeholder="code">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                <button type="submit" class="btn btn-primary">Submit</button>
            </div>
        </div>

    </form>
@endsection

resources/views/sub_category/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Edit Sub ategory</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('sub_category.index') }}" title="Go back"> <i
                        class="fas fa-backward "></i> </a>
            </div>
        </div>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            <strong>Whoops!</strong> There were some problems with your input.<br><br>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{ route('sub_category.update', $result['sub_category']->id) }}" method="POST">
        @csrf
        @method('PUT')

        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Name:</strong>
                    <input type="text" name="name" value="{{ $result['sub_category']->name }}" class="form-control" placeholder="Name">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Category:</strong>
                    <select class="form-control" name="category_id">
                        @foreach ($result['categories'] as $i => $category)
                        <option value="{{ $category->id }}"
                        @if ($result['sub_category']->category_id == $category->id)
                            selected="selected"
                        @endif
                        >{{$category->name}}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Code:</strong>
                    <input type="text" name="code" class="form-control" placeholder="{{ $result['sub_category']->code }}"
                        value="{{ $result['sub_category']->code }}">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                <button type="submit" class="btn btn-primary">Submit</button>
            </div>
        </div>

    </form>
@endsection

resources/views/sub_category/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Sub Categories</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-success" href="{{ route('sub_category.create') }}" title="Create a Sub Category"> <i class="fas fa-plus-circle"></i>
                    </a>
            </div>
        </div>
    </div>

    @if ($message = Session::get('success'))
        <div class="alert alert-success">
            <p>{{ $message }}</p>
        </div>
    @endif

    <table class="table table-bordered table-responsive-lg">
        <tr>
            <th align="center">No</th>
            <th>Name</th>
            <th>Category</th>
            <th>Code</th>
            <th>Is Active</th>
            <th>Created At</th>
            <th>Products of sub-category</th>
            <th width="280px">Action</th>
        </tr>
        @foreach ($sub_categories as $sub_category)
            <tr>
                <td>{{ ++$i }}</td>
                <td>{{ $sub_category->name }}</td>
                <td>{{ $sub_category->category->name }}</td>
                <td>{{ $sub_category->code }}</td>
                <td>{{ $sub_category->is_active }}</td>
                <td>{{ $sub_category->created_at->format('jS M Y') }}</td>
                <td align="center">
                    <a href="{{ url('sub_category/products/'.$sub_category->id) }}" title="show">
                        <i class="fas fa-align-justify  fa-lg"></i>
                    </a>
                </td>
                <td>
                    <form action="{{ route('sub_category.destroy', $sub_category->id) }}" method="POST">
                        <a href="{{ route('sub_category.show', $sub_category->id) }}" title="show">
                            <i class="fas fa-eye text-success  fa-lg"></i>
                        </a>

                        <a href="{{ route('sub_category.edit', $sub_category->id) }}">
                            <i class="fas fa-edit  fa-lg"></i>

                        </a>
                        @csrf
                        @method('DELETE')
                        <button type="submit" title="delete" style="border: none; background-color:transparent;">
                            <i class="fas fa-trash fa-lg text-danger"></i>

                        </button>
                    </form>
                </td>
            </tr>
        @endforeach
    </table>

    {!! $sub_categories->links() !!}

@endsection

resources/views/sub_category/show.blade.php
@extends('layouts.app')


@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2> {{ $sub_category->name }}</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('sub_category.index') }}" title="Go back"> <i
                        class="fas fa-backward "></i> </a>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Name:</strong>
                {{ $sub_category->name }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Category:</strong>
                {{ $sub_category->category->name }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Code:</strong>
                {{ $sub_category->code }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Created At:</strong>
                {{ $sub_category->created_at->format('jS M Y') }}
            </div>
        </div>
    </div>
@endsection